/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 2; tab-width: 2 -*- */
/* gdome-xml-eventl.h
 *
 * Copyright (C) 1999 Raph Levien <raph@acm.org>
 * Copyright (C) 2000 Mathieu Lacage <mathieu@gnu.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */

/* ----------------------------------------------------------------------- */
/* ---------------------------  EventListener  --------------------------- */
/* ----------------------------------------------------------------------- */

#ifndef GDOME_FILE_EVENTL
#define GDOME_FILE_EVENTL

#include "gdome-events.h"

typedef struct _Gdome_xml_EventListener Gdome_xml_EventListener;
typedef struct _Gdome_xml_EventListenerPriv Gdome_xml_EventListenerPriv;

struct _Gdome_xml_EventListener {
  GdomeEventListener super;
  int refcnt;
  Gdome_xml_EventListenerPriv *evntl;
};

struct _Gdome_xml_EventListenerPriv {
	void (*callback) (GdomeEventListener *self, 
			  GdomeEvent *event, 
			  GdomeException *exc);
	void *priv;
};


GdomeEventListener * 
gdome_xml_evntl_mkref (void (*callback) (GdomeEventListener *self, 
																				 GdomeEvent *event, 
																				 GdomeException *exc), 
											 void *priv);

void    * gdome_xml_evntl_get_argument      (GdomeEventListener *self);
void      gdome_xml_evntl_ref               (GdomeEventListener *self, 
																						 GdomeException *exc);
void      gdome_xml_evntl_unref             (GdomeEventListener *self, 
																						 GdomeException *exc);
void    * gdome_xml_evntl_query_interface   (GdomeEventListener *self, 
																						 const char *interface, 
																						 GdomeException *exc);
void      gdome_xml_evntl_handleEvent       (GdomeEventListener *self, 
																						 GdomeEvent *event, 
																						 GdomeException *exc);


const GdomeEventListenerVtab gdome_xml_evntl_vtab;

#endif /* GDOME_FILE_EVENTL */

