/* -*- Mode: C; indent-tabs-mode: t; c-basic-offset: 2; tab-width: 2 -*- */
/* gdome-xml-mevent.h
 *
 * Copyright (C) 1999 Raph Levien <raph@acm.org>
 * Copyright (C) 2000 Mathieu Lacage <mathieu@gnu.org>
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA  02111-1307, USA.
 */

/* ----------------------------------------------------------------------- */
/* ---------------------------  MutationEvent  --------------------------- */
/* ----------------------------------------------------------------------- */

#ifndef GDOME_MEVENT_FILE
#define GDOME_MEVENT_FILE


typedef struct _Gdome_xml_MutationEventPriv Gdome_xml_MutationEventPriv;
typedef struct _Gdome_xml_MutationEvent Gdome_xml_MutationEvent;

struct _Gdome_xml_MutationEventPriv {
	Gdome_xml_EventPriv ev;
	GdomeNode *relatedNode;
	GdomeDOMString *prevValue;
	GdomeDOMString *newValue;
	GdomeDOMString *attrName;
};
struct _Gdome_xml_MutationEvent {
  GdomeMutationEvent super;
  int refcnt;
  Gdome_xml_MutationEventPriv *mev;
};


GdomeNode        * gdome_xml_mevnt_target       (GdomeEvent *self, 
																								 GdomeException *exc);
GdomeNode        * gdome_xml_mevnt_relatedNode  (GdomeMutationEvent *self, 
																								 GdomeException *exc);
GdomeDOMString   * gdome_xml_mevnt_prevValue    (GdomeMutationEvent *self, 
																								 GdomeException *exc);
GdomeDOMString   * gdome_xml_mevnt_newValue     (GdomeMutationEvent *self, 
																								 GdomeException *exc);
GdomeDOMString   * gdome_xml_mevnt_attrName     (GdomeMutationEvent *self,
																								 GdomeException *exc);
void               gdome_xml_mevnt_initMutationEvent   (GdomeMutationEvent *self, 
																												GdomeDOMString *typeArg, 
																												GdomeBoolean canBubbleArg, 
																												GdomeBoolean cancelableArg, 
																												GdomeNode *relatedNodeArg, 
																												GdomeDOMString *prevValueArg, 
																												GdomeDOMString *newValueArg, 
																												GdomeDOMString *attrNameArg, 
																												GdomeException *exc);


const GdomeMutationEventVtab gdome_xml_mevnt_vtab;

#endif /* GDOME_MEVENT_FILE */
